/* 2011.8.26
****************************************
**  Copyright  (C)        1999-2011   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/

/*
********************************************** 
**
**  CH438 תമڽӿоƬ 
**
**  Ӳӿڲ㶨 ֱӵַʽ   
    A0-A5 --- PF0 -PF5
    A6    --- PF12
    D0-D1 --- PD14-PD15
    D2-D3 --- PD0 -PD1
    D4-D7 --- PE7 -PE10
    CS    --- PG9(NE2) BANK1NE1~NE4
    RD    --- PD4(NOE)
    WR    --- PD5(NWE)
    INT   --- PB10
**
**********************************************
*/

#include "include.h"


#define Bank1_SRAM3_ADDR    ((u32)(0x64000000))		
    
void FSMC_SRAM_Init(void)
{	
	GPIO_InitTypeDef  GPIO_InitStructure;
 
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE|RCC_APB2Periph_GPIOF|RCC_APB2Periph_GPIOG,ENABLE);
  	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC,ENABLE);
  
	GPIO_InitStructure.GPIO_Pin = 0xC033; 			 	//PORTD 
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOD, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = 0x0780; 			 	//PORTE 
 	GPIO_Init(GPIOE, &GPIO_InitStructure);

 	GPIO_InitStructure.GPIO_Pin = 0xF03F; 			 	//PORTD 
 	GPIO_Init(GPIOF, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = 0x0200; 			 	//PORTD 
 	GPIO_Init(GPIOG, &GPIO_InitStructure);


	FSMC_Bank1->BTCR[2] = 0x00000000;
	FSMC_Bank1->BTCR[3] = 0x00000000;
	FSMC_Bank1E->BWTR[2] = 0x00000000;
	FSMC_Bank1->BTCR[2]|=1<<14;		//дʹòͬʱ
	FSMC_Bank1->BTCR[2]|=1<<12;		//洢дʹ
	
	FSMC_Bank1->BTCR[3]|=(9<<8);    // ݽʱ䣨45ns
	FSMC_Bank1->BTCR[3]|=(1<<0);    // ַʱ䣨5ns
	
	FSMC_Bank1E->BWTR[2]|=12<<8;   	//дݱʱ(DATAST)	
	FSMC_Bank1E->BWTR[2]|=1<<0;		//дַʱ(ADDSET)

	FSMC_Bank1->BTCR[2]|=1<<0;		//ʹBANK12	
								
}

/**************************************************************************************************
** : INT_Init
** : ʼж	
** 䡡  : 
** 䡡  : 
*******************************************************************************************************/
void INT_Init(void)      //***ʼINT#**//
{
	GPIO_InitTypeDef GPIO_InitStructure;
	EXTI_InitTypeDef EXTI_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );	
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO,ENABLE);	//ʹܸùʱ
	
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU ;   //	
	GPIO_Init(GPIOB, &GPIO_InitStructure);	
	
	GPIO_EXTILineConfig(GPIO_PortSourceGPIOB, GPIO_PinSource10);  
	
    EXTI_InitStructure.EXTI_Line = EXTI_Line10;
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;  
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;
	
    EXTI_Init(&EXTI_InitStructure);

	NVIC_InitStructure.NVIC_IRQChannel = EXTI15_10_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
}

/*********************************************************************************************************
** : WriteCH438Data
** : ӿںCH438ַд
** 䡡: ַ,
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void WriteCH438Data( u8 addr, u8 dat)
{
	*(vu8*)(Bank1_SRAM3_ADDR+addr)=dat;
}

/*********************************************************************************************************
** : ReadCH438Data
** : ӿںCH438ַȡ
** 䡡: ַ
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
UINT8 ReadCH438Data( u8 addr )
{
  UINT8 dat;
    dat=*(vu8*)(Bank1_SRAM3_ADDR+addr); 
	return (dat);	

}

/*********************************************************************************************************
** : WriteCH438Block
** : ӿںCH438ַдݿ
** 䡡: CH438Ĵַ,ݿ鳤,ݻַ
**
** 䡡: 
**         
** ա: 2011826
**-------------------------------------------------------------------------------------------------------
** ޸:
** ա:
**-------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void WriteCH438Block( UINT8 mAddr, UINT8 mLen, PUINT8 mBuf )   
{

    while ( mLen -- ) 	
	  WriteCH438Data( mAddr, *mBuf++ );

}
